/*
 * WINNT POSIX Library
 * Version:  1.0
 * 
 * Copyright (C) 2002  Andrew Gnezdilov avi@risp.ru  All Rights Reserved.
 *
 * WINNT POSIX is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * WINNT POSIX is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with WINNT POSIX; see the file COPYING.  If not, write to
 * the Free Software Foundation, 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef _SETJMP_
#define _SETJMP_

#include <features.h>

/*
 * You may use set/longjmp routines with SEH and SEH based C++ exception handling.
 */

#ifdef _WIN64
# pragma pack (push, 8)
#else
# pragma pack (push, 4)
#endif

#include <bits/sigset.h>

__BEGIN_DECLS

#ifdef _X86_

typedef struct _jmp_buf {
/* 0*/  int edi;
/* 4*/  int esi;
/* 8*/  int ebx;
/*12*/  int ebp;
/*16*/  int esp;
/*20*/  int eip;
/*24*/  void *fs_0;
/*28*/  int mask_saved;
/*32*/  sigset_t mask;
} jmp_buf[1];

#else /* _X86_ */
# error Depended code.
#endif

EXTERNAPI int setjmp __P((jmp_buf buffer));
EXTERNAPI int sysv_setjmp __P((jmp_buf buffer)); /* MSVC compiler dosn't support _setjmp */
#define _setjmp(b) sysv_setjmp (b)
#if !defined	__FAVOR_BSD && !defined _INTERNAL_
# define setjmp(b) sysv_setjmp (b)
#else
# define setjmp(b) setjmp (b)
#endif

EXTERNAPI void longjmp (jmp_buf buffer, int value);
#if defined __USE_BSD || defined __USE_XOPEN
/* Same.  Usually `_longjmp' is used with `_setjmp', which does not save
   the signal mask.  But it is how ENV was saved that determines whether
   `longjmp' restores the mask. */
# define _longjmp(b, v) longjmp (b, v)
#endif /* __USE_BSD || __USE_XOPEN */

#ifdef	__USE_POSIX
/* Use the same type for `jmp_buf' and `sigjmp_buf'.
   The `mask_saved' flag determines whether
   or not `longjmp' will restore the signal mask.  */
typedef jmp_buf sigjmp_buf;

EXTERNAPI int sigsetjmp __P((jmp_buf buffer, int savemask));
/* Jump to the environment saved in ENV, making the
   sigsetjmp call there return VAL, or 1 if VAL is 0.
   Restore the signal mask if that sigsetjmp call saved it. */
# define siglongjmp(b, v) longjmp (b, v)
#endif /* Use POSIX. */

__END_DECLS

#pragma pack (pop)

#endif /* _SETJMP_ */