/*
 * WINNT POSIX Library
 * Version:  1.0
 * 
 * Copyright (C) 2002  Andrew Gnezdilov avi@risp.ru  All Rights Reserved.
 *
 * WINNT POSIX is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * WINNT POSIX is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with WINNT POSIX; see the file COPYING.  If not, write to
 * the Free Software Foundation, 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#if !defined (__need_wchar_t) && !defined (__need_size_t) \
  && !defined (__need_ptrdiff_t) && !defined (__need_NULL) && !defined (__need_wint_t)

# ifndef _STDDEF_
#  define _STDDEF_
# endif

# ifndef _STDDEF_H
#  define _STDDEF_H
# endif

# ifndef _STDDEF_H_
#  define _STDDEF_H_
# endif

# ifndef _ANSI_STDDEF_H
#  define _ANSI_STDDEF_H
# endif

# ifndef __STDDEF_H__
#  define __STDDEF_H__
# endif

# define offsetof(TYPE, MEMBER) ((size_t) &((TYPE *)0)->MEMBER)

#endif

#if (defined __need_NULL || defined _STDDEF_) && !defined NULL
# ifdef  __cplusplus
#  ifdef __GNUG__
#   define NULL __null
#  else
#   define NULL    0
#  endif
# else
#  define NULL    ((void *)0)
# endif
#endif
#undef __need_NULL

#if (defined __need_ptrdiff_t || defined _STDDEF_) && !defined _PTRDIFF_T_DEFINED
typedef long ptrdiff_t;
# define _PTRDIFF_T_DEFINED
# define _PTRDIFF_T
# define _T_PTRDIFF_
# define _T_PTRDIFF
# define __PTRDIFF_T
# define _PTRDIFF_T_
# define _BSD_PTRDIFF_T_
# define ___int_ptrdiff_t_h
# define _GCC_PTRDIFF_T
# undef _TYPE_ptrdiff_t
#endif
#undef __need_ptrdiff_t

#if (defined __need_size_t || defined _STDDEF_) && !defined _SIZE_T_DEFINED
typedef unsigned long size_t;
# define _SIZE_T_DEFINED
# define __size_t__	/* BeOS */
# define _SIZE_T
# define _SYS_SIZE_T_H
# define _T_SIZE_
# define _T_SIZE
# define __SIZE_T
# define _SIZE_T_
# define _BSD_SIZE_T_
# define _SIZE_T_DEFINED_
# define _SIZE_T_DEFINED
# define ___int_size_t_h
# define _GCC_SIZE_T
# define _SIZET_
# define __size_t
# undef _TYPE_size_t
#endif
#undef __need_size_t

#if (defined __need_wchar_t || defined _STDDEF_) && !defined _WCHAR_T_DEFINED
typedef unsigned short wchar_t;
# define _WCHAR_T_DEFINED
# define __wchar_t__	/* BeOS */
# define _WCHAR_T
# define _T_WCHAR_
# define _T_WCHAR
# define __WCHAR_T
# define _WCHAR_T_
# define _BSD_WCHAR_T_
# define _WCHAR_T_DEFINED_
# define _WCHAR_T_DEFINED
# define _WCHAR_T_H
# define ___int_wchar_t_h
# define __INT_WCHAR_T_H
# define _GCC_WCHAR_T
# undef _TYPE_wchar_t
#endif
#undef __need_wchar_t