/*
 * WINNT POSIX Library
 * Version:  1.0
 * 
 * Copyright (C) 2002  Andrew Gnezdilov avi@risp.ru  All Rights Reserved.
 *
 * WINNT POSIX is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * WINNT POSIX is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with WINNT POSIX; see the file COPYING.  If not, write to
 * the Free Software Foundation, 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef	_STRINGS_
#define	_STRINGS_

/* We don't need and should not read this file if <string.h> was already
   read. The one exception being that if __USE_BSD isn't defined, then
   these aren't defined in string.h, so we need to define them here.  */
#if !defined _STRING_ || !defined __USE_BSD

# include <features.h>
# define __need_size_t
# include <stddef.h>

__BEGIN_DECLS

/* Compare N bytes of S1 and S2 (same as memcmp).  */
EXTERNAPI int bcmp __P((const void *s1, const void *s2, size_t n));

/* Copy N bytes of SRC to DEST (like memmove, but args reversed).  */
EXTERNAPI void bcopy __P((const void *src, void *dest, size_t n));

/* Set N bytes of S to 0.  */
EXTERNAPI void bzero __P((void *s, size_t n));

/* Return the position of the first bit set in I, or 0 if none are set.
   The least-significant bit is position 1, the most-significant 32.  */
EXTERNAPI int ffs __P((int i));

/* Find the first occurrence of C in S (same as strchr).  */
EXTERNAPI char *index __P((const char *s, int c));

/* Find the last occurrence of C in S (same as strrchr).  */
EXTERNAPI char *rindex __P((const char *s, int c));

/* Compare S1 and S2, ignoring case.  */
EXTERNAPI int strcasecmp __P((const char *s1, const char *s2));

/* Compare no more than N chars of S1 and S2, ignoring case.  */
EXTERNAPI int strncasecmp __P((const char *s1, const char *s2, size_t n));

__END_DECLS

#endif	/* string.h  */

#endif	/* strings.h  */
